Package org.eclipse.emf.cdo.lm.client

# Interface ISystemDescriptor

All Superinterfaces:
  `Comparable<ISystemDescriptor>`, `org.eclipse.net4j.util.properties.IPropertiesContainer`

public interface ISystemDescriptor extends org.eclipse.net4j.util.properties.IPropertiesContainer, Comparable<ISystemDescriptor>

Author:
  Eike Stepper
No Implement
  This interface is not intended to be implemented by clients.
No Extend
  This interface is not intended to be extended by clients.

## Nested Class Summary

Nested Classes
Modifier and Type
Interface
Description
`static final class`
`ISystemDescriptor.ChangeDeletionException`
`static final class`
`ISystemDescriptor.ModuleDeletionException`
`static final class`
`ISystemDescriptor.ResolutionException`
`static enum`
`ISystemDescriptor.State`

## Method Summary

Modifier and Type
Method
Description
`Annotation`
`attachFingerPrint(FixedBaseline fixedBaseline)`
`void`
`close()`
`Map<String,CDOView>`
`configureModuleResourceSet(CDOView view)`
`Map<String,CDOView>`
`configureModuleResourceSet(ResourceSet resourceSet, Assembly assembly)`
`Change`
`createChange(Stream stream, FixedBaseline base, String label, IProgressMonitor monitor)`
`Delivery`
`createDelivery(Stream stream, Change change, LMMerger merger, IProgressMonitor monitor)`
`Drop`
`createDrop(Stream stream, DropType dropType, long timeStamp, String label, IProgressMonitor monitor)`
`Module`
`createModule(String name, ModuleType type, StreamSpec streamSpec, IProgressMonitor monitor)`
`Module`
`createModule(String name, StreamSpec streamSpec, IProgressMonitor monitor)`
`ResourceSet`
`createModuleResourceSet(Baseline baseline)`
`ResourceSet`
`createModuleResourceSet(CDOSession moduleSession, CDOBranchPoint branchPoint)`
`ResourceSet`
`createModuleResourceSet(CDOSession moduleSession, CDOBranchPoint branchPoint, boolean readOnly)`
`Stream`
`createStream(Module module, Drop base, StreamSpec streamSpec, IProgressMonitor monitor)`
`void`
`deleteChange(Change change, IProgressMonitor monitor)`
`void`
`deleteModule(Module module, IProgressMonitor monitor)`
`ModuleDefinition`
`extractModuleDefinition(Baseline baseline)`
`ModuleDefinition`
`extractModuleDefinition(FloatingBaseline baseline, long timeStamp)`
`ModuleDefinition`
`extractModuleDefinition(CDOView view)`
`String`
`getError()`
`String[]`
`getModuleNames()`
`CDORepository[]`
`getModuleRepositories()`
`CDORepository`
`getModuleRepository(String moduleName)`
`ISystemDescriptor.State`
`getState()`
`System`
`getSystem()`
`String`
`getSystemName()`
`CDORepository`
`getSystemRepository()`
`boolean`
`isOpen()`
`<E extends ModelElement, R>
R`
`modify(E element, Function<E,R> modifier, IProgressMonitor monitor)`
`<R> R`
`modify(Function<System,R> modifier, IProgressMonitor monitor)`
`void`
`open()`
`void`
`renameChange(Change change, String newLabel, IProgressMonitor monitor)`
`Assembly`
`resolve(ModuleDefinition rootDefinition, Baseline baseline, IProgressMonitor monitor)`
`boolean`
`verifyFingerPrint(FixedBaseline fixedBaseline)`
`boolean`
`withModuleSession(String moduleName, Consumer<CDOSession> consumer)`
`boolean`
`withModuleSession(CDORepository moduleRepository, Consumer<CDOSession> consumer)`

### Methods inherited from interface java.lang.Comparable

`compareTo`

### Methods inherited from interface org.eclipse.net4j.util.properties.IPropertiesContainer

`properties`

## Method Details

### getSystemRepository

CDORepository getSystemRepository()

### getSystemName

String getSystemName()

### getSystem

System getSystem()

### getError

String getError()

### getState

ISystemDescriptor.State getState()

### isOpen

boolean isOpen()

### open

void open()

### close

void close()

### modify

<E extends ModelElement, R> R modify(E element, Function<E,R> modifier, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### modify

<R> R modify(Function<System,R> modifier, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### getModuleNames

String[] getModuleNames()

Since:
  1.2

### getModuleRepositories

CDORepository[] getModuleRepositories()

Since:
  1.2

### getModuleRepository

CDORepository getModuleRepository(String moduleName)

### withModuleSession

boolean withModuleSession(String moduleName, Consumer<CDOSession> consumer)

### withModuleSession

boolean withModuleSession(CDORepository moduleRepository, Consumer<CDOSession> consumer)

Since:
  1.2

### extractModuleDefinition

ModuleDefinition extractModuleDefinition(Baseline baseline)

### extractModuleDefinition

ModuleDefinition extractModuleDefinition(FloatingBaseline baseline, long timeStamp)

### extractModuleDefinition

ModuleDefinition extractModuleDefinition(CDOView view)

### createModuleResourceSet

ResourceSet createModuleResourceSet(Baseline baseline) throws ISystemDescriptor.ResolutionException

Throws:
  `ISystemDescriptor.ResolutionException`
Since:
  1.4

### createModuleResourceSet

ResourceSet createModuleResourceSet(CDOSession moduleSession, CDOBranchPoint branchPoint) throws ISystemDescriptor.ResolutionException

Throws:
  `ISystemDescriptor.ResolutionException`
Since:
  1.5

### createModuleResourceSet

ResourceSet createModuleResourceSet(CDOSession moduleSession, CDOBranchPoint branchPoint, boolean readOnly) throws ISystemDescriptor.ResolutionException

Throws:
  `ISystemDescriptor.ResolutionException`
Since:
  1.5

### configureModuleResourceSet

Map<String,CDOView> configureModuleResourceSet(CDOView view) throws ISystemDescriptor.ResolutionException

Throws:
  `ISystemDescriptor.ResolutionException`
Since:
  1.3

### configureModuleResourceSet

Map<String,CDOView> configureModuleResourceSet(ResourceSet resourceSet, Assembly assembly)

Since:
  1.3

### resolve

Assembly resolve(ModuleDefinition rootDefinition, Baseline baseline, IProgressMonitor monitor) throws ISystemDescriptor.ResolutionException

Throws:
  `ISystemDescriptor.ResolutionException`

### createModule

Module createModule(String name, StreamSpec streamSpec, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### createModule

Module createModule(String name, ModuleType type, StreamSpec streamSpec, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### deleteModule

void deleteModule(Module module, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException, ISystemDescriptor.ModuleDeletionException

Throws:
  `ConcurrentAccessException`
  `CommitException`
  `ISystemDescriptor.ModuleDeletionException`

### createStream

Stream createStream(Module module, Drop base, StreamSpec streamSpec, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### createDrop

Drop createDrop(Stream stream, DropType dropType, long timeStamp, String label, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### createChange

Change createChange(Stream stream, FixedBaseline base, String label, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### renameChange

void renameChange(Change change, String newLabel, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### deleteChange

void deleteChange(Change change, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException, ISystemDescriptor.ChangeDeletionException

Throws:
  `ConcurrentAccessException`
  `CommitException`
  `ISystemDescriptor.ChangeDeletionException`

### createDelivery

Delivery createDelivery(Stream stream, Change change, LMMerger merger, IProgressMonitor monitor) throws ConcurrentAccessException, CommitException

Throws:
  `ConcurrentAccessException`
  `CommitException`

### attachFingerPrint

Annotation attachFingerPrint(FixedBaseline fixedBaseline) throws CommitException

Throws:
  `CommitException`
Since:
  1.6

### verifyFingerPrint

boolean verifyFingerPrint(FixedBaseline fixedBaseline)

Since:
  1.6